DROP TABLE education;
CREATE TABLE education ( SSN int NOT NULL, EDUCATION char(50), EDUENROLL char(50), PRIMARY KEY (SSN) ); 
DROP TABLE employmentstat;
CREATE TABLE employmentstat ( SSN int NOT NULL, UNEMPLOYMENTREASON char(50), EMPLOYMENTSTAT char(50), PRIMARY KEY (SSN) ) ;
DROP TABLE geo;
CREATE TABLE geo ( REGION char(50) NOT NULL, RESSTATE char(50) NOT NULL, PRIMARY KEY (RESSTATE) );
DROP TABLE industry;
CREATE TABLE industry ( INDUSTRYCODE int NOT NULL, INDUSTRY char(50), STABILITY int, PRIMARY KEY (INDUSTRYCODE) ) ;
DROP TABLE investment;
CREATE TABLE investment ( SSN int NOT NULL, CAPITALGAINS int, CAPITALLOSSES int, STOCKDIVIDENDS int, PRIMARY KEY (SSN) ) ;
DROP TABLE job;
CREATE TABLE job ( SSN int NOT NULL, WORKCLASS char(50), INDUSTRYCODE int, OCCUPATIONCODE int, UNIONMEMBER char(50), EMPLOYERSIZE int, WEEKWAGE int, SELFEMPLOYED smallint, WORKWEEKS int, PRIMARY KEY (SSN) ) ;
DROP TABLE migration;
CREATE TABLE migration ( SSN int NOT NULL, MIGRATIONCODE char(50), MIGRATIONDISTANCE char(50), MIGRATIONMOVE char(50), MIGRATIONFROMSUNBELT char(50), PRIMARY KEY (SSN) ) ;
DROP TABLE occupation;
CREATE TABLE occupation ( OCCUPATIONCODE int NOT NULL, OCCUPATION char(50), STABILITY int, PRIMARY KEY (OCCUPATIONCODE) ) ;
DROP TABLE stateabbv;
CREATE TABLE stateabbv ( ABBV char(2) NOT NULL, NAME char(50) NOT NULL ) ;
DROP TABLE userrecord;
CREATE TABLE userrecord ( NAME char(50), ZIP char(5), SSN int NOT NULL, AGE int, SEX char(50), MARITAL char(50), RACE char(50), TAXSTAT char(50), DETAIL char(100), HOUSEHOLDDETAIL char(100), FATHERORIGIN char(50), MOTHERORIGIN char(50), BIRTHCOUNTRY char(50), CITIZENSHIP char(50), PRIMARY KEY (SSN) ) ;
DROP TABLE wage;
CREATE TABLE wage ( INDUSTRYCODE int NOT NULL, OCCUPATIONCODE int NOT NULL, MEANWEEKWAGE int, PRIMARY KEY (INDUSTRYCODE, OCCUPATIONCODE) ) ;
DROP TABLE youth;
CREATE TABLE youth ( SSN int NOT NULL, PARENTS char(50), PRIMARY KEY (SSN) ) ;
DROP TABLE ziptable;
CREATE TABLE ziptable ( ZIP char(5), CITY char(20), STATENAME char(20), COUNTY char(20) ) ;
ALTER TABLE education ADD FOREIGN KEY (SSN) REFERENCES userrecord (SSN);
ALTER TABLE employmentstat ADD FOREIGN KEY (SSN) REFERENCES userrecord (SSN);
ALTER TABLE investment ADD FOREIGN KEY (SSN) REFERENCES userrecord (SSN);
ALTER TABLE job ADD FOREIGN KEY (OCCUPATIONCODE) REFERENCES occupation (OCCUPATIONCODE) ;
ALTER TABLE job ADD FOREIGN KEY (SSN) REFERENCES userrecord (SSN) ;
ALTER TABLE job ADD FOREIGN KEY (INDUSTRYCODE) REFERENCES industry (INDUSTRYCODE);
ALTER TABLE migration ADD FOREIGN KEY (SSN) REFERENCES userrecord (SSN);
ALTER TABLE wage ADD FOREIGN KEY (INDUSTRYCODE) REFERENCES industry (INDUSTRYCODE) ;
ALTER TABLE wage ADD FOREIGN KEY (OCCUPATIONCODE) REFERENCES occupation (OCCUPATIONCODE);
ALTER TABLE youth ADD FOREIGN KEY (SSN) REFERENCES userrecord (SSN);
