package durbodax.customers.Enums;

import java.util.Map;
import java.util.HashMap;
import java.util.EnumSet;

/**
 *
 * @author Kirk Seddon
 */
public enum EmploymentStatus { 
    
    //See EMPSTAT Table
    NA(0), 
    EMPLOYED(1), 
    UNEMPLOYED(2), 
    NOT_IN_LABOR_FORCE(3);
    
    private static final Map<Integer, EmploymentStatus> lookup = new HashMap<Integer, EmploymentStatus>();
    private int code;
    
    static {
        
        for(EmploymentStatus employment : EnumSet.allOf(EmploymentStatus.class)) {
            
            lookup.put(employment.getCode(), employment);
            
        }
        
    }
    
    private EmploymentStatus(int code) {
        
        this.code = code;
        
    }
    
    public int getCode() {
        
        return code;
        
    }
    
    public static EmploymentStatus getStatus(int code) {
     
        return lookup.get(code);
        
    }

}
